#!/usr/bin/python
import cgi
import os
import sys

HTML_TEMPLATE = """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>File Upload</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="expires" content="0">
<meta name="robots" content="noindex">
<style type="text/css">
text {
    font-family: Verdana, Arial, Sans serif;
    font-size: 12px;
 	font-weight: bold;
 	}
a {
    color: #0099CC;
    font-family: Verdana;
    font-size: 10px;
 	font-weight: normal;
	color: #000000;
	margin-top: 8px;
	margin-bottom: 12px;
    text-decoration: none;
}
a:hover {
    text-decoration: underline;
}

body, textarea, td {
    color: #000000;
    font-family: Verdana;
    font-size: 11px;
    font-weight: normal;
    text-decoration: none;
}

h1 {
    font-family: Verdana, Arial, Sans serif;
    font-size: 11px;
 	font-weight: bold;
	margin-top: 0px;
	margin-bottom: 12px;

}

h3 {
    font-family: Verdana, Arial, Sans serif;
    font-size: 12px;
 	font-weight: bold;
	color: #000000;
	margin-top: 8px;
	margin-bottom: 12px;

}
</style>
</head>

<body bgcolor="#FFFFFF" text="#000000" leftmargin="0" topmargin="10" marginwidth="0"
marginheight="0">

<table width="902" border="0" align="center" cellspacing="0" cellpadding="0" style="border: solid 1px #000000;">
  <tr>
    <td colspan="2" align="center" valign="middle" width="900"> <img src="Header.jpg" border="0"></td>
  </tr>
  <tr>
    <td colspan="2" align="center" height="50" valign="middle" width="900">
    <h1>File Upload</h1>
    </td>
  </tr>
  <tr>
    <td align="left" height="230" width="200" valign="middle"></td>
    <td align="left" height="230" valign="middle" width="700">
    <p>&nbsp;</p>
    %(MessageStr)s
    <p>&nbsp;</p>
    </td>
  </tr>
  %(ReturnLink)s
</table>
</body>
</html>
"""


MessageUserResourceZip = """
 <h1><p><img src="ok.png"> user_resource upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The user_resource folder has been uploaded correctly.</p>
"""

MessageMacroXml = """
 <h1><p><img src="ok.png"> macroxx.xml upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The macroxx.xml file has been uploaded correctly.</p>
"""

MessagePagesXml = """
 <h1><p><img src="ok.png"> pages.xml upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The pages.xml file has been uploaded correctly.</p>
"""

MessageImagePng = """
 <h1><p><img src="ok.png"> image.png upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The image.png file has been uploaded correctly.</p>
"""

MessageRemoveUserRes = """
 <h1><p><img src="ok.png"> remove_user_resource remove OK</p>
 </h1><p>&nbsp;</p>
 <p>The user_resource folder has been removed sucessfully.</p>
"""

MessageBackgroundBmp = """
 <h1><p><img src="ok.png"> Background Bitmap upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The background bitmap file has been uploaded correctly.<br>The changed bitmap will be shown if "Individual Design" has been selected.</p>
"""

MessageScreenSaver = """
 <h1><p><img src="ok.png"> Screen saver image upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The screen saver image file has been uploaded correctly.<br>
    The changed image will be shown the next time the screen saver is invoked.</p>
"""

MessageConfigData = """
 <h1><p><img src="ok.png"> Config Data upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>ConfigData.bin</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
"""

MessageConfigDataXml = """
 <h1><p><img src="ok.png"> XML Config Data upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>ConfigData.xml</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
"""

MessageApp = """
 <h1><p><img src="ok.png"> Application upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>xtouchPANEL_NT</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
"""

MessageTestBookData = """
 <h1><p><img src="ok.png"> Test Book Data upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>TestBook.bin</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
"""

MessageUpdateData = """
 <h1><p><img src="ok.png"> Software Update upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>%(file)s</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
"""

MessageUploadFail = """
 <h1><p><img src="fail.png"> File upload FAILED.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>%(file)s</b> could not be uploaded correctly.<br>The reason may be either an incorrect filename or an unsupported format. Please retry.</p>
"""

ReturnLinkActive = """
  <tr>   
    <td align="left" height="40" width="200" valign="middle"></td>
    <td align="left" height="40" valign="middle" width="700">
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="update.htm">return to upload page</a></p>
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="index.htm">return to main page</a></p>
    <p>&nbsp;</p>
    </td>
  </tr>
"""

ReturnLinkReboot = """
  <tr>   
    <td align="left" height="40" width="200" valign="middle"></td>
    <td align="left" height="40" valign="middle" width="700">
	<p>After reboot you may want to:<p>
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="update.htm">return to upload page</a></p>
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="index.htm">return to main page</a></p>
    <p>&nbsp;</p>
    </td>
  </tr>
"""


MessageStr = MessageUploadFail;
ReturnLink = ReturnLinkActive;
form_field = 'UploadFile';


def print_html_form (fname):
    """This prints out the html form. Note that the action is set to
      the name of the script which makes this is a self-posting form.
      In other words, this cgi both displays a form and processes it.
    """
    MsgStr = MessageStr % {'file':fname}
    RetStr = ReturnLink % {'file':fname}
    print "content-type: text/html\n"
    print HTML_TEMPLATE % {'MessageStr':MsgStr, 'ReturnLink':RetStr}



def save_uploaded_file (upload_dir, fileitem):
    if "" == fileitem.filename:
	    return 0 
    if not os.path.exists(upload_dir):
	    try:
	        os.makedirs(upload_dir)
	    except OSError as exc: # Guard against race condition
	        if exc.errno != errno.EEXIST:
	            raise
    fout = file (os.path.join(upload_dir, fileitem.filename), 'wb')

    while 1:
        chunk = fileitem.file.read(100000)
        if not chunk: 
            break
        fout.write (chunk)
    fout.close()
    return 1


form = cgi.FieldStorage()
MessageStr = MessageUploadFail
if not form.has_key(form_field):
    print_html_form("")   
else:
    fileitem = form[form_field]
    if fileitem.file:
        if "" == fileitem.filename:
            print_html_form("")  
        else:        
            if "screensaver.png" == str(fileitem.filename).lower():
                MessageStr = MessageScreenSaver;
                save_uploaded_file("/home/resource", fileitem);
            elif "background.png" == str(fileitem.filename).lower():
                MessageStr = MessageBackgroundBmp;
                save_uploaded_file("/home/resource", fileitem) ;    
            elif "ConfigData.bin" == fileitem.filename:
                MessageStr = MessageConfigData;
                ReturnLink = ReturnLinkReboot;
                save_uploaded_file("/home", fileitem);  
                os.system("/sbin/reboot");
            elif "ConfigData.xml" == fileitem.filename:
                MessageStr = MessageConfigDataXml;
                ReturnLink = ReturnLinkReboot;
                save_uploaded_file("/home", fileitem);  
                os.system("/sbin/reboot");
            elif "DALIDisplay_V" == str(fileitem.filename)[0:13] and ".zip" == str(fileitem.filename)[-4:].lower():
                MessageStr = MessageUpdateData;
                ReturnLink = ReturnLinkReboot;
                os.system("/usr/loader/loader &");  
                os.system("/bin/sleep 1");              
                save_uploaded_file("/temp", fileitem);                                
            elif "xtouchPANEL_NT" == str(fileitem.filename):
                MessageStr = MessageApp;
                ReturnLink = ReturnLinkReboot;
                os.system("/usr/bin/pkill xtouchPANEL_NT");
                save_uploaded_file("/home", fileitem);
            elif "pages.xml" == str(fileitem.filename).lower():
                save_uploaded_file("/home/user_resource", fileitem);
                MessageStr = MessagePagesXml;
            elif ".xml" == str(fileitem.filename).lower()[-4:] and "macro" in str(fileitem.filename):
                save_uploaded_file("/home/user_resource", fileitem);
                MessageStr = MessageMacroXml;
            elif "user_resource.zip" == str(fileitem.filename).lower():
                os.system("rm -rf /home/user_resource");
                save_uploaded_file("/home/user_resource", fileitem);
                os.system("unzip -q -o /home/user_resource/" +str(fileitem.filename)+" -d /home/user_resource/");
                os.system("rm -rf /home/user_resource/"+str(fileitem.filename));
                if (0 == os.system("ls /home/user_resource/user_resource")):
                        os.system("cp -a /home/user_resource/user_resource/. /home/user_resource/");
                        os.system("rm -rf /home/user_resource/user_resource");
                MessageStr = MessageUserResourceZip;
            elif "user_resource.tar" == str(fileitem.filename).lower():
                os.system("rm -rf /home/user_resource");
                save_uploaded_file("/home/user_resource", fileitem);
                os.system("tar -xf /home/user_resource/"+str(fileitem.filename) +" -C /home/");
                os.system("rm -rf /home/user_resource/"+str(fileitem.filename));
                if (0 == os.system("ls /home/user_resource/user_resource")):
                        os.system("cp -a /home/user_resource/user_resource/. /home/user_resource/");
                        os.system("rm -rf /home/user_resource/user_resource");
                MessageStr = MessageUserResourceZip;
            elif "remove_user_resource" == str(fileitem.filename).lower():
                os.system("rm -rf /home/user_resource");
                MessageStr = MessageRemoveUserRes;
            elif ".png" == str(fileitem.filename)[-4:].lower():
                if (0 == os.system("ls /home/user_resource/")):
                    os.system("mkdir /home/user_resource")
                MessageStr = MessageImagePng
                save_uploaded_file("/home/user_resource", fileitem);
            os.system("sync");
            print_html_form(fileitem.filename)
sys.exit(0)



