#!/bin/sh
FILEFIFO="/usr/loader/PUBLIC"
LoaderAppTitle="USB-Loaderv4.0"
ImageName="/usr/loader/usb1.jpg"
MESSAGE1=" "
MESSAGE2=" "
export DISPLAY=:0.0

#Otherwise the web browser prints echos, etc.
exec 1>/dev/null 2>/dev/null

#loaderPipeServer X1 X2 X3 X4
#X1 fifo file
#X2 app title
#X3 label text
#X4 jpeg to display

#loaderClient X1 X2y1y2y3
#X1 fifo file
#X2 text - last 3 letters are important
#y1 size of font 
#possible values 1 -arial 12
#2 -arial 14
#3 -arial 16
#y2 - color of fonts -r red, -b black
#y3 - progress bar type and stop
#p - progress bar -pulse
#n - progress-bar -fill 100%
#s - Exit from thread, close sockets

#test and quiet

#if not started only - start it !
if [ -z $(ps -ef |grep loaderPipeServer | grep -v grep) ]; then
    rm $FILEFIFO
    /usr/loader/loaderPipeServer $FILEFIFO $LoaderAppTitle "Starting Update" $ImageName &  #run server as background
    while [ -z $(ps -ef |grep loaderPipeServer | grep -v grep) ];
    do
      sleep 1
    done
fi;

/usr/loader/loaderPipeClient $FILEFIFO "Copying files. Please wait...2bp"
if [ -d /temp/AutoRun2/ ] ; then
    MESSAGE1="Success! The system will reboot.3gn"
    MESSAGE2="ERROR! The system will reboot.3rn"
    tar xvf /temp/AutoRun2/files.tar -C /
else	
  if [ -f /mnt/usb/AutoRun2/files.tar ] ; then
    MESSAGE1="Success! The system will be rebooted. Please remove the usb stick.3gn"
    MESSAGE2="ERROR! Please remove the usb stick.3rn"
    tar xvf /mnt/usb/AutoRun2/files.tar -C /
  elif [ -f /mnt/usb/AutoRun2/user_resource.zip ] ; then
    MESSAGE1="user_resource.zip loaded OK! Please remove the usb stick.3gn"
    MESSAGE2="user_resource.zip ERROR! Please remove the usb stick.3rn"
    if ! [ -d /home/user_resource/ ] ; then
      mkdir /home/user_resource
    fi
    unzip -q /mnt/usb/AutoRun2/user_resource.zip -d /home/user_resource/
    if [ -d /home/user_resource/user_resource/ ] ; then
      cp -a /home/user_resource/user_resource/. /home/user_resource/
      rm -rf /home/user_resource/user_resource
    fi
  fi
fi
RETCODE=$?
	if [ $RETCODE == 0 ]; then
	    /usr/loader/loaderPipeClient $FILEFIFO "$MESSAGE1"
    else
	    /usr/loader/loaderPipeClient $FILEFIFO "$MESSAGE2"
fi
sed -i 's/"reboot_required": false/"reboot_required": true/g' /usr/loader/.config/'last update'
exit $RETCODE
